/*
===================================================
Created by: Alex Wolfe :: Fall 2010
Based off the processing noise() sample code
http://processing.org/reference/noise_.html
Concept Studio :: Silent Visualizer :: 3D Sound Waves
===================================================
*/

float yOffset = 0;
float noiseScale=0.02;
float noiseVal;
float perlinStep = 0.00;
float STEP = 0.02;


void setup() 
{
  //size(screen.width,screen.height/2,P3D);
  size( 640, 480, P3D);
  
  rectMode( CENTER );
  textAlign( CENTER, CENTER );
  textSize( 14 );
}

void draw() 
{
  makeWaves();                       // create waves
  yOffset = ((yOffset+1)%height);    // change offset for next iteration
  
  showFrameRate( );
}

void makeWaves()
{
  background(0,0,30);          //refresh background to erase previous pixel draw
      //move vertically down the screen
  for(float y=0; y < (height); y=y+1.5) 
  {   
    perlinStep = perlinStep + STEP;         
      //step through perlin noise space to get distinct waves
    for(int x=0; x<(width/2); x=x+1) 
    {
            // generate the perlin value
        noiseVal = noise(  (perlinStep+x)*noiseScale,
                           (perlinStep+y)*2*noiseScale, 
                           y*noiseScale);
            //create color map
        stroke(255-(noiseVal*255),(y+noiseVal*80), 150 -(noiseVal*y)); 
           //draw individual pixels, x,y,z using perlin noise function
        point(x*2, (yOffset+(y+noiseVal*80))%height, y*noiseVal);       
    }
  }
}

void showFrameRate( )
{
   fill( 200, 200,20 );
   noStroke( );
   rect( 50,  20, 50, 20 );
   fill( 0 );
   text( frameRate, 50, 20 ); 
}


