// Noise in 3-d

import processing.opengl.*;

float xStart, yStart, zStart, xNoise, yNoise, zNoise;

float sampleSize;

float rotx, roty, rotz, transx, transy, transz;

void setup( )
{
  size( 1200, 900, OPENGL);
  sphereDetail( 8 );
  noStroke( );
  
  xStart = random( 10 );
  yStart = random( 10 );
  zStart = random( 10 );
  
  sampleSize = 20;
  
  rotx = 15;
  transz = -438;
  
  rectMode( CENTER );
  //frameRate( 12 );
  
  textSize( 18 );
  textAlign( CENTER );
}

void draw( )
{
  background( 255 );
  pushMatrix( );
    translate( transx, transy, transz );
    rotateX( radians( rotx ) );
    rotateY( radians( roty ) );
    rotateZ( radians( rotz ) );
    xStart += 0.01;
    yStart += 0.01;
    zStart += 0.01;
    
    xNoise = xStart;
    yNoise = yStart;
    zNoise = zStart;
    
    drawGrid( );
  popMatrix( );
  
  drawInstructions( );

}

void drawInstructions( )
{
   fill( 0 );
   text( "Translations:  X axis: [left]/[right]  || Y axis [up]/[down] || Z axis [i]/[o]", width/2, height*.85);
   text( "Rotations:     X axis: [X]/[x]  || Y axis [Y]/[y] || Z axis [Z]/[z]", width/2, height*.90);   
   text( "Reset to Original:  [space bar]", width/2, height*.95);
}

void drawGrid( )
{
   for( int y = 0; y <= height; y+= sampleSize )
  {
    yNoise += 0.1;
    xNoise = xStart;
    for( int x = 0; x <= width; x+= sampleSize )
    {
      xNoise += 0.1;
     drawPoint( x, y-height/2, noise( xNoise, yNoise ) ); 
    }
  } 
}

void drawPoint( float x, float y, float noiseFactor )
{
   if ( keyPressed ) println(frameRate);
   float sphereSize = noiseFactor * sampleSize*5 ;
   float gray = 150 + ( noiseFactor * 120 );
   //float alph = 150 + ( noiseFactor * 120 );
   float alph = 255-(255*noiseFactor);
   //float alph = 50;
   //fill( 0, gray, 0, alph);
   fill( y, alph );
   pushMatrix( );
   
     translate( x, 250 - y, -y /*+ sphereSize/2*/);
 
     //sphere( sphereSize );
     box( sampleSize, sampleSize,  sphereSize*5);
     //rect( 0, 0, sphereSize, sphereSize*3);
   popMatrix( ); 
}

void keyPressed( )
{
   
   switch(keyCode)
   {
     case UP:  transy-=3; break;
     case DOWN:  transy+=3; break;
     case LEFT:  transx-=3; break;
     case RIGHT:  transx+=3; break;
     default:
      switch( key )
      {
          case 'i' : transz+=3; break;
          case 'o' : transz-=3; break;
          case 'x' : rotx++; break;
          case 'X' : rotx--; break;
          case 'y' : roty++; break;
          case 'Y' : roty--; break;
          case 'z' : rotz++; break;
          case 'Z' : rotz--; break;
          case ' ' : transy = transz = rotx = roty =0;
                     rotx = 15;
                     transz = -438;
                     break;
          
      }  
   }
   
   println( "rx= " + rotx + " ry= " + roty + " rz= " + rotz + " tz= "  + transz);
}
